using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.IO;
using System.Diagnostics;

namespace DSPerformanceTest
{
    struct BasicPersonInformation
    {
        public string strName;
        public string strAddress1;
        public string strAddress2;
    }
    public partial class DSPerformanceTestForm : Form
    {
        private List<BasicPersonInformation> m_BasicPersonInfoArray = new List<BasicPersonInformation>();
        private Dictionary<string, BasicPersonInformation> m_BasicPersonInfoTable = new Dictionary<string, BasicPersonInformation>();
        private ArrayList m_ParsonInfoArrayList = new ArrayList();
 
        private List<string> m_ResultInfoArray = new List<string>();

        public DSPerformanceTestForm()
        {
            InitializeComponent();
        }

        private void DSPerformanceTestForm_Load(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void buttonStartTest_Click(object sender, EventArgs e)
        {

            int iNoOfRecords = Convert.ToInt32(textBoxNoOfRecordsToLoad.Text);

            string strStatus = "Loading the data structure into List<T>" ;

            labelStatus.Text = strStatus;

            this.Refresh();

            DateTime InitialTime=DateTime.Now;

            for (int i = 0; i < iNoOfRecords; i++)
            {
                BasicPersonInformation Info = new BasicPersonInformation();
                Info.strName = textBoxName.Text + i.ToString();
                Info.strAddress1 = textBoxAddress1.Text;
                Info.strAddress2 = textBoxAddress2.Text;
                m_BasicPersonInfoArray.Add(Info);
            }

            DateTime FinalTime = DateTime.Now;
            StoreTheResultsInotArray(strStatus, InitialTime, FinalTime);


            strStatus = "Loading the data structure into ArrayList";

            labelStatus.Text = strStatus;

            this.Refresh();

            InitialTime = DateTime.Now;


            for (int i = 0; i < iNoOfRecords; i++)
            {
                BasicPersonInformation Info = new BasicPersonInformation();
                Info.strName = textBoxName.Text + i.ToString();
                Info.strAddress1 = textBoxAddress1.Text;
                Info.strAddress2 = textBoxAddress2.Text;
                m_ParsonInfoArrayList.Add(Info);
            }

            FinalTime = DateTime.Now;
            StoreTheResultsInotArray(strStatus, InitialTime, FinalTime);



            strStatus = "Loading the data structure into Dictionary<T1,T2>" ;

            labelStatus.Text = strStatus;

            this.Refresh();
            InitialTime = DateTime.Now;

            for (int i = 0; i < iNoOfRecords; i++)
            {
                BasicPersonInformation Info = new BasicPersonInformation();
                Info.strName = textBoxName.Text + i.ToString();
                Info.strAddress1 = textBoxAddress1.Text;
                Info.strAddress2 = textBoxAddress2.Text;
                m_BasicPersonInfoTable.Add(Info.strName,Info);

            }

            FinalTime = DateTime.Now;
            StoreTheResultsInotArray(strStatus, InitialTime, FinalTime);


            strStatus = "Searching the specified record in List<T> ";

            labelStatus.Text = strStatus;
            this.Refresh();

            InitialTime = DateTime.Now;

            for (int i = 0; i < m_BasicPersonInfoArray.Count; i++)
            {
                if (m_BasicPersonInfoArray[i].strName == textBoxNameToFind.Text)
                {
                    break;
                }
            }

            FinalTime = DateTime.Now;
            StoreTheResultsInotArray(strStatus, InitialTime, FinalTime);


            strStatus = "Searching the specified record in ArrayList";

            labelStatus.Text = strStatus;
            this.Refresh();

            InitialTime = DateTime.Now;

            for (int i = 0; i < m_ParsonInfoArrayList.Count; i++)
            {
                if (((BasicPersonInformation)m_ParsonInfoArrayList[i]).strName == textBoxNameToFind.Text)
                {
                    break;
                }
            }

            FinalTime = DateTime.Now;
            StoreTheResultsInotArray(strStatus, InitialTime, FinalTime);



            strStatus = "Searching the specified record in Dictionary<T1,T2>";

            labelStatus.Text = strStatus;

            this.Refresh();

            InitialTime = DateTime.Now;

            BasicPersonInformation value ;
            if (m_BasicPersonInfoTable.TryGetValue(textBoxNameToFind.Text, out value))
            {
                FinalTime = DateTime.Now;
                StoreTheResultsInotArray(strStatus, InitialTime, FinalTime);
            }
            else
            {
                FinalTime = DateTime.Now;
                StoreTheResultsInotArray("Failed to search in Hash Table", InitialTime, FinalTime);
            }

            
            labelStatus.Text = "Displaying the results";

            this.Refresh();


            float iDataStructureSize = (float)((textBoxName.Text.Length + textBoxAddress1.Text.Length + textBoxAddress2.Text.Length) * Convert.ToInt32(textBoxNoOfRecordsToLoad.Text)) / (float)(1048576);

            DisplayTheResults(textBoxNoOfRecordsToLoad.Text, textBoxNameToFind.Text, iDataStructureSize);

            labelStatus.Text = "Clearing the data structure";

            this.Refresh();

            m_BasicPersonInfoArray.Clear();
            m_ParsonInfoArrayList.Clear();
            m_BasicPersonInfoTable.Clear();
            m_ResultInfoArray.Clear();

        }

        private void StoreTheResultsInotArray(string strStatus, DateTime InitialTime, DateTime FinalTime)
        {
            
            TimeSpan Difference = FinalTime - InitialTime;
            string strResult = strStatus + " Time Delay:->Minutes:" + Difference.Minutes.ToString() + " Seconds:" + Difference.Seconds.ToString() + " MilliSeconds:" + Difference.Milliseconds.ToString();
            m_ResultInfoArray.Add(strResult);

        }

        private void DisplayTheResults(string strNoOfRecords, string strToFind,float DataStructureSize)
        {
            using (TextWriter streamWriter = new StreamWriter("PerformanceResult.txt"))
            {
                streamWriter.WriteLine("C#.NET Data Structure Peformance Test");
                streamWriter.WriteLine("========================================");
                streamWriter.WriteLine("");

                streamWriter.WriteLine("No Of Records:->" + strNoOfRecords + " String to Find-->" + strToFind);

                streamWriter.WriteLine("");
                streamWriter.WriteLine("Total Size for each Data Structure:->" + DataStructureSize.ToString() + " MB");

                streamWriter.WriteLine("");
                for (int i = 0; i < m_ResultInfoArray.Count; i++ )
                {
                    streamWriter.WriteLine(m_ResultInfoArray[i]);
                }
                streamWriter.Close();
            }
            Process.Start("Notepad", "PerformanceResult.txt");

        }

        private void textBoxNameToFind_TextChanged(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }
                
    }
}